// Uses the correct large-large greedy direction.
// But incorrectly assumes the matching upperbound on the second list is going to monotonically decreasing.
// This is a way to get cheaty efficiency.
// It should get WA on small-sized breaker instead of TLE.

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <sstream>
#include <complex>
#include <ctime>
#include <cassert>
#include <functional>

using namespace std;

typedef long long ll;
typedef vector<int> VI;
typedef pair<int,int> PII;

#define REP(i,s,t) for(int i=(s);i<(t);i++)
#define FILL(x,v) memset(x,v,sizeof(x))

const int INF = (int)1E9 + 5;
#define MAXN 200005

int n, p, q, a[MAXN], b[MAXN];
bool v[MAXN];
bool solve(int D, int S) {
  FILL(v ,0);
  int ans = 0, lastj = q - 1;
  for (int i = p - 1; i >= 0; i--) {
    for (int j = lastj; j >= 0; j--) {
      if (a[i] + b[j] > S || abs(a[i] - b[j]) > D || v[j]) continue;
      v[j] = 1;
      lastj = j;
      if (++ans >= n) return true;
    }
  }
  return false;
}

int main() {
  int S;
  cin >> n >> p >> q >> S;
  REP(i,0,p) cin >> a[i];
  REP(i,0,q) cin >> b[i];
  sort(a, a + p);
  sort(b, b + q);
  int l = 0, r = INF;
  while (l <= r) {
    int m = (l + r) / 2;
    if (solve(m, S)) r = m - 1;
    else l = m + 1;
  }
  cout << (l >= INF ? -1 : l) << endl;
  return 0;
}
